; /**
; * SoundEffect is a convenience class which provides a simple
; * mechanism For basic Sound playback.  There are two types of Sound
; * effects: single And Multiple.  single Sound effects only allow
; * the Sound To be played Once at a time.  Multiple Sound effects
; * always Open a new stream To the audio device For Each time it is
; * played (cleaning up Or reusing old streams If possible).
; */
Enumeration
  #audiere
EndEnumeration

IncludeFile "audiere.pbi"
  
If OpenLibrary(#audiere,"audiere.dll")=0
MessageRequester("","Error audiere.dll",0):End:EndIf
    
                                                ; opens a device
AudioDeviceObject.AudioDevice=AUDIERE_OpenDevice(@"winmm",@"buffer=100,rate=44100")    
    If AudioDeviceObject=0
    MessageRequester("","Error AUDIERE_OpenDevice:",0):End:EndIf


                                                 ; opens a music
SampleSourceObject.SampleSource= AUDIERE_OpenSampleSource(@"machinae_supremacy_-_sidstyler.ogg",#FF_AUTODETECT) 
    If SampleSourceObject=0
    MessageRequester("","Error AUDIERE_OpenSampleSource",0):End:EndIf



;   /**
;    * Open a SoundEffect object from the given sample Source And Sound
;    * effect type.  @See SoundEffect
;    *
;    * @param device  AudioDevice on which the Sound is played.
;    *
;    * @param Source  the sample Source used To feed the Sound effect
;    *                with Data.
;    *
;    * @param type  the type of the Sound effect.  If type is Multiple,
;    *              the Source must be seekable.
;    *
;    * @Return  new SoundEffect object If successful, 0 otherwise
SoundEffectObject.SoundEffect=AUDIERE_OpenSoundEffect(AudioDeviceObject,SampleSourceObject,#MULTIPLE)  
    If SoundEffectObject=0                                        
    MessageRequester("","Error OpenSound",0):End:EndIf 




SoundEffectObject\play()                              ; play the soundEffect


MessageRequester("","Press OK to stop the sound",0)


SoundEffectObject\stop()                              ; stop the soundEffect


SoundEffectObject\ref()                         ; refcounter+1
SoundEffectObject\unref()                       ; delete the object (refCounter-1)
                                                ; Note:
                                                ; it isn't necessary to delete the 
                                                ; SampleSourceObject and the AudioDeviceObject
                                                ; I hadn't figured out yet why ..
CloseLibrary(#audiere)

; ExecutableFormat=Windows
; CursorPosition=24
; FirstLine=1
; EOF