; /**
; * SoundEffect is a convenience class which provides a simple
; * mechanism For basic Sound playback.  There are two types of Sound
; * effects: single and multiple.  Single sound effects only allow
; * the sound to be played once at a time.  Multiple sound effects
; * always open a new stream to the audio device for each time it is
; * played (cleaning up or reusing old streams if possible).
; */
Enumeration
  #audiere
EndEnumeration

IncludeFile "audiere.pbi"
  
If OpenLibrary(#audiere,"audiere.dll")=0
MessageRequester("","Error audiere.dll",0):End:EndIf
    
                                                ; opens a device
AudioDeviceObject.AudioDevice=AUDIERE_OpenDevice(@"winmm",@"buffer=100,rate=44100")    
    If AudioDeviceObject=0
    MessageRequester("","Error AUDIERE_OpenDevice:",0):End:EndIf


                                                ; opens a music
SampleSourceObject.SampleSource= AUDIERE_OpenSampleSource(@"machinae_supremacy_-_sidstyler.ogg",#FF_AUTODETECT) 
    If SampleSourceObject=0
    MessageRequester("","Error AUDIERE_OpenSampleSource",0):End:EndIf


                                                ; open a SoundEffect Object
SoundEffectObject.SoundEffect=AUDIERE_OpenSoundEffect(AudioDeviceObject,SampleSourceObject,#MULTIPLE)  
    If SoundEffectObject=0                                        
    MessageRequester("","Error OpenSound",0):End:EndIf 



; /**
; * Trigger playback of the sound.  If the SoundEffect is of type
; * single, This plays the sound If it isn't playing yet, and
; * starts it again If it is.  If the SoundEffect is of type
; * multiple, play() simply starts playing the sound again.
SoundEffectObject\play()                        ; play the soundEffect


MessageRequester("","Press OK to play a second sound because the SoundEffect is #MULTIBLE",0)


SoundEffectObject\play()                        ; play the soundEffect


MessageRequester("","Press OK to play a third sound because the SoundEffect is #MULTIBLE",0)


SoundEffectObject\play()                        ; play the soundEffect


MessageRequester("","Press OK to stop this mess because the SoundEffect is #MULTIBLE",0)


                                              
SoundEffectObject\stop()                        ; stop all SoundEffects because 
                                                ; he SoundEffect is #MULTIBLE


SoundEffectObject\ref()                         ; refcounter+1
SoundEffectObject\unref()                       ; delete the object (refCounter-1)
                                                ; Note:
                                                ; it isn't necessary to delete the 
                                                ; SampleSourceObject and the AudioDeviceObject
                                                ; I hadn't figured out yet why ..
CloseLibrary(#audiere)

; ExecutableFormat=Windows
; CursorPosition=24
; FirstLine=1
; EOF