; /**
; * SoundEffect is a convenience class which provides a simple
; * mechanism For basic sound playback.  There are two types of sound
; * effects: single and multiple.  Single sound effects only allow
; * the sound to be played once at a time.  Multiple sound effects
; * always open a new stream to the audio device for each time it is
; * played (cleaning up or reusing old streams if possible).
; */

; *
; * Please Note:
; *
; * All methods which give back a float variable do it via a fpu register.
; * To put the value into you variable you have to do the following:
; *   Global _floatresult.f
; *   !FST dword[v__floatresult]
; * After that is the value in _floatresult.f
; *
Enumeration
  #audiere
EndEnumeration

IncludeFile "audiere.pbi"

  
If OpenLibrary(#audiere,"audiere.dll")=0
MessageRequester("","Error audiere.dll",0):End:EndIf
    
                                                ; opens a device
AudioDeviceObject.AudioDevice=AUDIERE_OpenDevice(@"winmm",@"buffer=100,rate=44100")    
    If AudioDeviceObject=0
    MessageRequester("","Error AUDIERE_OpenDevice:",0):End:EndIf


                                                ; opens a music
SampleSourceObject.SampleSource= AUDIERE_OpenSampleSource(@"machinae_supremacy_-_sidstyler.ogg",#FF_AUTODETECT) 
    If SampleSourceObject=0
    MessageRequester("","Error AUDIERE_OpenSampleSource",0):End:EndIf


                                                ; open a SoundEffect Object
SoundEffectObject.SoundEffect=AUDIERE_OpenSoundEffect(AudioDeviceObject,SampleSourceObject,#MULTIPLE)  
    If SoundEffectObject=0                                        
    MessageRequester("","Error OpenSound",0):End:EndIf 



; /**
; * Sets the Sound's volume.
; *
; * @param  volume  0.0 = silence, 1.0 = maximum volume (Default)
; */
SoundEffectObject\setVolume(0.5)                ; set the volume to 0.5
MessageRequester("","Press OK to start the SoundEffect with volume 0.5",0)
SoundEffectObject\play()                        ; play the first soundEffect


SoundEffectObject\setVolume(1.0)                ; set the volume to 0.5
MessageRequester("","Press OK to start another SoundEffect but with volume 1.0",0)
SoundEffectObject\play()                        ; play the second soundEffect
                                                ; because the SoundEffect Object is #MULTIPLE

SoundEffectObject\getVolume()                   ; get the volume
Global _floatresult.f
!FST dword[v__floatresult]                      ; and put it in _floatresult.f


MessageRequester("","The volume from the last SoundEffect is"+StrF(_floatresult),0)


SoundEffectObject\stop()                        ; stop the soundEffect



SoundEffectObject\ref()                         ; refcounter+1
SoundEffectObject\unref()                       ; delete the object (refCounter-1)
                                                ; Note:
                                                ; it isn't necessary to delete the 
                                                ; SampleSourceObject and the AudioDeviceObject
                                                ; I hadn't figured out yet why ..
CloseLibrary(#audiere)

; ExecutableFormat=Windows
; CursorPosition=35
; FirstLine=1
; EOF