Declare.l OpenDevice(help1.s)
Declare.s GetAllTypes()
Declare   GetDevices()

Enumeration
  #audiere
  #MWindow
  #OpenFile
  #Play      
  #FileName  
  #InfoText  
  #Stop      
  #List1     
  #Frame1    
  #DevText    
  #Volume     
  #VolText    
  #Pan
  #PanText
  #Pitch
  #PitchText
EndEnumeration

IncludeFile "audiere.pbi"

Dim DeviceName.s(100)

;*
;* Open a device to play
;*
Procedure.l OpenDevice(help1.s)
  AudioDeviceObject.AudioDevice=AUDIERE_OpenDevice(@help1.s,@"buffer=100,rate=44100")    
  If AudioDeviceObject=0
  MessageRequester("","Error during open a new device:"+help1.s,0):End:EndIf
  DisableGadget(#List1,1)
  ProcedureReturn AudioDeviceObject
EndProcedure
  
;*
;* Get all sound format possibillities
;* description1:ext1,ext2,ext3;description2:ext1,ext2,ext3
;*
Procedure.s GetAllTypes()
  help1.s=PeekS(AUDIERE_GetSupportedFileFormats())
  pattern.s=""
  For i=1 To 100
    help2.s=StringField(help1.s, i, ";")  ; kompletter Typ
    help3.s=StringField(help2,1,":")      
    pattern.s=pattern.s+help3.s+"|"
    For u=1 To 50
      help4.s=RemoveString(StringField(RemoveString(help2.s,help3.s),u,","),":")
      If help4.s<>""
        pattern.s=pattern.s+"*."+help4.s+";"
      EndIf
    Next
    pattern.s=Left(pattern.s,Len(pattern.s)-1)
    pattern.s+"|"
  Next
  ProcedureReturn pattern.s
EndProcedure
  
  
  
;*
;* Store all possible Devices in device.s(n)
;*
Procedure GetDevices()
  help1.s=PeekS(AUDIERE_GetSupportedAudioDevices())
  For i=1 To 20
    help2.s=StringField(help1.s,i,";")
    If Len(help2.s)>4
      AddGadgetItem(#List1,-1,StringField(help2.s,2,":"))
      DeviceName.s(i)=StringField(help2.s,1,":")                  ; insert the devicenames
    EndIf
  Next
EndProcedure
  
  
  
  
  
;*
;* Open the window
;*
hndMWindow=OpenWindow(#MWindow,200,200,400,240,#PB_Window_SystemMenu,"Audiere Music Player Technical Demo V1.04")
If hndMWindow=0 : MessageRequester("Error","Cant open the Window",0):End:EndIf

;*
;* Load the library
;*
hndLib=OpenLibrary(#audiere,"audiere.dll")
If hndLib=0 :  MessageRequester("Error","Cant open the audiere.dll",0):End:EndIf

;*
;* Set the gadgets
;*
If CreateGadgetList(WindowID(#MWindow))
  TextGadget(#InfoText,10,10,300,24,"Version info:           "+PeekS(AUDIERE_GetVersion()))
  ButtonGadget(#OpenFile,10,40,80,24,"Select a file")
  TextGadget(#FileName,100,40,310,26,"")
  ButtonGadget(#Play,10,70,80,24,"Play")
  ButtonGadget(#Stop,10,100,80,24,"Stop")
  Frame3DGadget(#Frame1,10,130,250,80,"Choose a device at first !",#PB_Frame3D_Flat    )
  ListViewGadget(#List1, 13, 145, 244, 63)
  TextGadget(#DevText,10,220,250,27,"Actual device:")
  TrackBarGadget(#Volume,270,60,30,160,0,100,#PB_TrackBar_Vertical)
  TextGadget(#VolText,276,225,30,100,"1.00")
  TrackBarGadget(#Pan,310,60,30,160,0,200,#PB_TrackBar_Vertical)
  TextGadget(#PanText,316,225,30,100,"0.00")
  TrackBarGadget(#Pitch,344,60,30,160,0,150,#PB_TrackBar_Vertical)
  TextGadget(#PitchText,350,225,30,100,"1.00")
EndIf
  
;*
;* Store the name of the Devices in devices.s(n)
;*
GetDevices()
  
;*
;* Create the pattern for the Requester
;*
pattern.s=GetAllTypes()
  
;*
;* Set the start values of the TrackbarRequester
;*
  
SetGadgetState(#Volume,100)    ; set maximum volume 
SetGadgetState(#Pan,100)       ; set middle pan
SetGadgetState(#Pitch,100)     ; set the usual pitch
  
quit=#False     ; quit program if quit=#TRUE
  
Repeat
  Event=WaitWindowEvent()
  
  Select Event
      Case #PB_Event_Gadget
          Select EventGadgetID()
              Case #OpenFile                                  ; shows the requester
                  name.s=OpenFileRequester("Choose a file","",pattern.s,1)
                  If Len(name.s)>4
                    SetGadgetText(#FileName,name.s)
                  EndIf
            
            
              Case #Play                                    
                  If AudioDeviceObject.AudioDevice=0
                    MessageRequester("","Select a Device at first",0)
                  Else
                    If Len(name.s)>4
                      SampleSourceObject.SampleSource=AUDIERE_OpenSampleSource(@name.s,#FF_AUTODETECT)  ; get the sound
                      If SampleSourceObject=0 : MessageRequester("Error","Error creating a new SampleSource",0) : End:EndIf
                      OutputStreamObject.OutputStream=AUDIERE_OpenSound(AudioDeviceObject,SampleSourceObject,#False); and create a stream
                      If OutputStreamObject=0 : MessageRequester("","Error creating a new OutputStream",0):End:EndIf
                      OutputStreamObject\play()                 ; and play the stream
                    EndIf 
                  EndIf
            
            
              Case #Stop
                  If OutputStreamObject=0
                    MessageRequester("","Play a sound at first",0)
                  Else
                    OutputStreamObject\stop()                   ; stop the stream
                  EndIf
            
            
              Case #Volume
                  If OutputStreamObject
                    help1.f=GetGadgetState(#Volume)/100
                    SetGadgetText(#VolText,StrF(help1,2))
                    OutputStreamObject\setVolume(help1.f)       ; set the new volume
                  EndIf
          
            
              Case #Pan
                  If OutputStreamObject
                    help1.f=GetGadgetState(#Pan)/100-1
                    SetGadgetText(#PanText,StrF(help1,3))
                    OutputStreamObject\setPan(help1.f)          ; set the new pan
                  EndIf


              Case #Pitch
                  If OutputStreamObject
                    help1.f=(GetGadgetState(#Pitch)+50)/100
                    SetGadgetText(#PitchText,StrF(help1,3))
                    OutputStreamObject\setPitchShift(help1.f)    ; set the new Pitch
                  EndIf


              Case #List1
                  AudioDeviceObject.AudioDevice=OpenDevice(DeviceName.s(GetGadgetState(#List1)+1)) ; get the Object with the AudioDeviceObject
                  SetGadgetText(#DevText,"Actual device:"+DeviceName.s(GetGadgetState(#List1)+1))



          EndSelect

      Case #PB_Event_CloseWindow
      
          If OutputStreamObject<>0
            OutputStreamObject\ref()        ; RefCount+1
            OutputStreamObject\unref()      ; deletes the OutputStreamObject refcounter-1
          EndIf
          If AudioDeviceObject<>0
            AudioDeviceObject\ref()         ; RefCount+1
            AudioDeviceObject\unref()       ; deletes the AudioDeviceObject refcounter-1
          EndIf
          quit=#True  
                                            ; Note:
                                            ; It is not necessary to delete the SampleSource
                                            ; object because AUDIEREOpenSound takes over it.        
        
      EndSelect
Until quit=#True
  
CloseLibrary(#audiere)
CloseWindow(#MWindow)
; ExecutableFormat=Windows
; CursorPosition=151
; FirstLine=110
; EOF